<?php
/*
Plugin Name: EasyVideoPlayer 2.0
Plugin URI: http://www.seodenver.com/easy-video-player/
Description: A simple, attractive way to Easy Video Player videos into your WordPress website.
Author: Katz Web Services, Inc.
Version: 1.0
Author URI: http://www.katzwebservices.com

Copyright 2010 Katz Web Services, Inc.  (email: info@katzwebservices.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/		

add_action('media_buttons_context', 'evp_add_form_button', 99999); // Add media buttons
add_action('init', 'evp_tinymce_addbuttons'); // Add tinyMCE buttons

function evp_tinymce_addbuttons() {
	// Don't bother doing this stuff if the current user lacks permissions
	if ( ! current_user_can('edit_posts') && ! current_user_can('edit_pages') )
	return;
	// Add only in Rich Editor mode
	if ( get_user_option('rich_editing') == 'true') {
		add_filter("mce_external_plugins", "evp_add_custom_tinymce_plugin");
		add_filter('mce_buttons', 'evp_register_custom_button');
	}
}
function evp_register_custom_button($buttons) {
	array_push($buttons, "|", "wpevp");
	return $buttons;
}

function evp_add_custom_tinymce_plugin($plugin_array) {
	$plugin_array['wpevp'] = plugin_dir_url(__FILE__).'evp_editor_plugin.js';
	return $plugin_array;
}

function evp_add_form_button($context){
    $image_btn = plugin_dir_url(__FILE__).'images/button.gif';
    $out = '<a href="#TB_inline?width=450&inlineId=insert_evp" class="thickbox" title="' . __("Embed EVP", 'wpevp') . '"><img src="'.$image_btn.'" alt="' . __("Embed EVP Video", 'wpevp') . '" /></a>';
    return $context . $out;
}


// This is where the actual generation of the video code happens.
add_shortcode('wpevp', 'wpevp_shortcode');

function wpevp_shortcode($atts, $content=NULL) {
	
	extract(shortcode_atts(array(
		'id' => '',
		'src' => '',
		'init' => '',
		'class' => 'evp-video-wrap',
	), $atts));

/*
<div id="evp-af181db34640a283c675c232b8d6ee7f-wrap" class="evp-video-wrap"></div>
<script type="text/javascript" src="http://omar-martin.com/evp/framework.php?div_id=evp-af181db34640a283c675c232b8d6ee7f&amp;#038;id=bWFpbmJsb2d2aWRlby0xLm00dg%3D%3D&amp;#038;v=1287162407&amp;#038;profile=default"></script>
<script type="text/javascript">_evpInit('bWFpbmJsb2d2aWRlby0xLm00dg==');</script>

<div id="evp-af181db34640a283c675c232b8d6ee7f-wrap" class="evp-video-wrap"></div>
<script type="text/javascript" src="http://omar-martin.com/evp/framework.php?div_id=evp-af181db34640a283c675c232b8d6ee7f&#038;id=bWFpbmJsb2d2aWRlby0xLm00dg%3D%3D&#038;v=1287162407&#038;profile=default"></script><script type="text/javascript"><!--
_evpInit('bWFpbmJsb2d2aWRlby0xLm00dg==');//--></script>
*/

if(!empty($id) && !empty($src) && !empty($init)) {
	$src = html_entity_decode($src);
	$init = html_entity_decode($init);
	$code = <<<EOD
<!-- Begin Easy Video Player plugin Output -->
<div id="$id" class="$class"></div>
<script type="text/javascript" src="$src"></script>
<script type="text/javascript"><!--
_evpInit('$init');
//--></script>
<!-- End Easy Video Player plugin Output -->
EOD;
} else {
	$code = '<!-- Easy Video Player plugin was missing required information, so the video was not displayed. -->';
}
	return $code;
}

// Add the inline thickbox content
add_action('admin_init', 'evp_register_scripts');
function evp_register_scripts() {
	global $pagenow;
	if(in_array($pagenow, array('post.php', 'page.php', 'page-new.php', 'post-new.php'))){
		add_action('admin_footer',  'evp_add_mce_popup');
	}
}

//Action target that displays the popup to insert a form to a post/page
function evp_add_mce_popup(){
    ?>
    <script type="text/javascript"><!--
    	jQuery('document').ready(function($) { 
    		$('#evp_insert_button').click(function(e) {
    			InsertEVP();
    			return false;
    		});

    		function InsertEVP(){
    			var win = window.dialogArguments || opener || parent || top;
				var code = $("#evp_code").val();
				// Strip out line breaks
				code = code.replace(/\s+/gs, ' ');
				var imgCode = '';
				code.replace(/(?:.*?)id=['"](.*?)['"](?:.*?)class=['"](.*?)['"](?:.*?)src=['"](.*?)['"](?:.*?)\_evpInit\(['"](.*?)['"]\)(?:.*)/gs, function(a,b,c,d,e){
					console.log('$1: '+a); console.log('$2: '+b); console.log('$3: '+c); console.log('$4: '+d); console.log('$5: '+e);
					
					if(win.tinyMCE.hasVisual) {
						imgCode = '<img src="<?php echo plugin_dir_url(__FILE__).'images/placeholder.jpg'; ?>" class="wpevp mceItem" title="wpevp id=&quot;'+tinymce.DOM.encode(b)+'&quot; class=&quot;'+tinymce.DOM.encode(c)+'&quot; src=&quot;'+tinymce.DOM.encode(d)+'&quot; init=&quot;'+tinymce.DOM.encode(e)+'&quot;"  />';
					} else {
						imgCode = '[wpevp id="'+tinymce.DOM.encode(b)+'" class="'+tinymce.DOM.encode(c)+'" src="'+tinymce.DOM.encode(d)+'" init="'+tinymce.DOM.encode(e)+'"]';
					}
				});
				
                if(imgCode != '') {
                	$('#wpevp_error').remove();
                	$('#evp_code').val('');
	                win.send_to_editor(imgCode);
	                win.tinyMCE.execCommand('mceCleanup');
	           	} else {
	           		$('#evp_code').before('<div class="error wrap" id="wpevp_error"><p>There was an error with the code entered.</p></div>');
	           	}
            }
    		
    	});
    -->
    </script>

	
    <div id="insert_evp" style="display:none;">
        <div class="wrap">
            <div>
                <div class="wrap">
                    <h3 style="color:#5A5A5A!important; font-family:Georgia,Times New Roman,Times,serif!important; font-size:1.8em!important; font-weight:normal!important;"><?php _e("Embed an EVP video into this WordPress post", "wpevp"); ?></h3>
                    <p>
                        <?php _e("Please enter the code provided by EasyVideoPlayer below. You can embed both video and audio files.", "wpevp"); ?>
                    </p>
                    <div class="inline-edit-row">
                    <fieldset>
                    <textarea id="evp_code" class="widefat" rows="7"></textarea>
					<p>
						<?php _e("Once you click Insert Video below, your ideo code will be stored inside your post and it will show up as an image in the Visual editor. <strong>Do NOT</strong> try and modify dimensions, etc. from within WordPress as this will not work!", "wpevp"); ?>
					</p>
					</fieldset>
					</div>
                </div>
                
                <div class="submit">
                    <input type="button" class="button-primary" value="Insert Video" id="evp_insert_button" />&nbsp;&nbsp;&nbsp;
	                <a class="button" style="color:#bbb;" href="#" onclick="tb_remove(); return false;"><?php _e("Cancel", "wpevp"); ?></a>
                </div>
            </div>
        </div>
    </div>

    <?php
}

?>